# -*- coding: cp1251 -*-
import os, smtplib, pymaconf, pymalog

class pysender:
	def __init__(self):
		mtf = os.path.dirname(__file__) + os.path.sep + 'mime.types'
		mt = open(mtf, 'r').readlines()
		self.mimetypes = {}
		for line in mt:
			mimetype, mimeext = line[:-1].split()
			self.mimetypes[mimeext] = mimetype


	messagepart = '''From: %(fromaddr)s
To: %(toaddr)s
Subject: %(subject)s
X-Mailer: PyMa 0.1
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="%(boundary)s"

This is a multi-part message in MIME format.

--%(boundary)s
Content-Type: text/plain; charset="%(codepage)s"
Content-Transfer-Encoding: Base64

%(message)s
'''

	attachpart = '''--%(boundary)s
Content-Type: %(mimetype)s; name="%(filename)s"
Content-Transfer-Encoding: base64
Content-Disposition: attachment; filename="%(filename)s"

%(mimed)s'''


	def getmimetypebyext(self, ext):
		try:
			mt = self.mimetypes[ext]
		except:
			mt = 'application/octet-stream'
		return mt


	def sendfiles(self, toaddr, filelist):

		param = {}
		param['boundary'] = '-=-=_BOUNDARY_adba_YRADNUOB_=-=-'
		param['fromaddr'] = pymaconf.fromaddr
		if pymaconf.backmail and pymaconf.backaddr:
			param['toaddr'] = toaddr + '\nBcc: ' + pymaconf.backaddr
			envtoaddr = [toaddr]
			envtoaddr.append(pymaconf.backaddr)
		else:
			param['toaddr'] = toaddr
			envtoaddr = [toaddr]
			
		param['subject']  = pymaconf.defsubject
		param['message']  = pymaconf.defmessage
		param['codepage'] = pymaconf.mailcodepage

		param['message'] = smtplib.base64.encodestring(param['message'])

		msg = self.messagepart % param

		files = ''
		print 'pysender: MIME- :'
		for filename in filelist:
			files += filename + ','
			param['filename']  = filename
			base, ext = os.path.splitext(filename)
			param['mimetype']  = self.getmimetypebyext(ext[1:])
			print 'pysender:    + %s...' %  filename

			ist = open(filename, 'rb').read()
			param['mimed'] = smtplib.base64.encodestring(ist)
			msg = msg + (self.attachpart % param)
		
		
		print 'pysender:   %s...' % pymaconf.smtpserver
		try:
			session = smtplib.SMTP(pymaconf.smtpserver)
			if pymaconf.authrequire:
				session.login(pymaconf.authlogin, 
					      pymaconf.authpassword)

			print 'pysender:  ...'
			session.sendmail(pymaconf.fromaddr, envtoaddr, msg)
			print 'pysender:  .'
			session.quit()

			pymalog.write('SENT:  %s to %s' % (files, toaddr))

		except:
			print 'pysender:  .'
			pymalog.write('ERROR: %s to %s' % (files, toaddr))
		