#!/usr/local/bin/python
# -*- coding: cp1251 -*-

#############################################################################
#  Utility for send files by e-mail from command line
#----------------------------------------------------------------------------
#  Usage:
#     send to <addr> files <file1[ file2...]> [(nonzipped | as <zip>)]
#############################################################################

import sys, os, glob, myzip, pymaconf
from mystd import mystdin, mystdout
from pysender import pysender

class pyma:
	def __init__(self):
		self.FLG_NZ = False
		self.ZIPNAME = ''

	def parseParameters(self, *argv):
		STOP = 0
		if len(argv) < 5:
			self.Usage()
		if argv[1][:2] != 'to':
			self.Usage()
		if argv[3][:2] != 'fi':
			self.Usage()
		self.TO = self.getaddrbyalias(argv[2])
		if argv[-1][:2] == 'no':
			self.FLG_NZ = True
			STOP = -1
		elif argv[-2][:2] == 'as':
			self.ZIPNAME = argv[-1]
			STOP = -2
		else:
			self.ZIPNAME = zn = argv[4]
			if zn.find('*') > -1 or zn.find('?') > -1:
				self.ZIPNAME = 'archive.zip'
		self.ZIPNAME = unicode(self.ZIPNAME, 
			pymaconf.fsyscodepage).encode(pymaconf.fzipcodepage)

		if self.ZIPNAME[-4:] != '.zip':
			self.ZIPNAME = self.ZIPNAME + '.zip'

		if STOP:
			files = argv[4:STOP]
		else:
			files = argv[4:]
		if not files:
			self.Usage()

		self.FILELIST = []
		for pattern in files:
			tmplist = glob.glob(pattern)
			for file in tmplist:
				if os.path.isfile(file):
					self.FILELIST.append(file)
		if not self.FILELIST:
			print '\nERROR: no files found.'
			self.Usage()

		if pymaconf.promptsubj:
			tmp = raw_input('Subject: ')
			if tmp:
				pymaconf.defsubject = tmp
			print

		if pymaconf.promptmess:
			tmp = raw_input('Message: ')
			if tmp:
				pymaconf.defmessage = tmp
			print


	def getaddrbyalias(self, addr):
		abf = os.path.dirname(__file__) + os.path.sep + 'addrbook.ab'
		ab = open(abf, 'r').readlines()
		aliases = {}
		for line in ab:
			alias, fulladdr = line.split()
			aliases[alias] = fulladdr
		try:
			fulladdr = aliases[addr]
		except:
			fulladdr = addr
		return fulladdr

	def sendmail(self):
		self.parseParameters(*sys.argv)
		if self.FLG_NZ:
			pysender().sendfiles(self.TO, self.FILELIST)
		else:
			myzip.writepattzip(self.ZIPNAME, self.FILELIST)
			pysender().sendfiles(self.TO, (self.ZIPNAME,))
			os.remove(self.ZIPNAME)

	def Usage(self):
		print '''--------------------------------------------------
Utility for send files by e-mail from command line
Usage:
   send to <addr> files <file1[ file2...]> [(nonzipped | as <zip>)]'''
		sys.exit()
		
	
	
if __name__ == '__main__':
	mo = mystdout()
	mi = mystdin()
	mo.setmystdout()
	mi.setmystdin()
	nc = pyma()
	nc.sendmail()
	mo.setorigin()
	mi.setorigin()
